#define MASTER           // CAN 1st Node
//#define SLAVE              // CAN 2nd Node

unsigned long Can_Init_Flags;
unsigned char Can_Send_Flags, Can_Rcv_Flags; // can flags
unsigned char Rx_Data_Len;                                   // received data length in bytes
char RxTx_Data[8];                                           // can rx/tx data buffer
char Msg_Rcvd;                                               // reception flag
const long ID_1st = 12111, ID_2nd = 3;                       // node IDs
long Rx_ID;
char old_message = 0xFF;
char port_rd;
char port_rd_temp;
char CAN_Button;
extern char LED;

unsigned int LED1 = 1, LED2 = 1, LED3 = 1, LED4 = 1, LED5 = 1, LED6 = 1, LED7 = 1, LED8 = 1;

void doCAN() {
  char i, flag;

  Can_Init_Flags = 0;                                       //
  Can_Send_Flags = 0;                                       // clear flags
  Can_Rcv_Flags  = 0;                                       //
  
  Can_Send_Flags = _CAN_TX_XTD_FRAME &                      //     with CANWrite
                   _CAN_TX_NO_RTR_FRAME;

  Can_Init_Flags = _CAN_CONFIG_AUTOMATIC_RETRANSMISSION &          // form value to be used
                   _CAN_CONFIG_RX_FIFO_NOT_LOCKED_ON_OVERRUN &     // with CANInit
                   _CAN_CONFIG_TIME_TRIGGERED_MODE_DISABLED &
                   _CAN_CONFIG_TX_FIFO_PRIORITY_BY_IDINTIFIER &
                   _CAN_CONFIG_WAKE_UP;

  CAN1InitializeAdvanced(1,5,4,4,1,Can_Init_Flags, &_GPIO_MODULE_CAN1_PD01);  // Initialize CAN module
  CAN1SetOperationMode(_CAN_OperatingMode_Initialization);                    // set CONFIGURATION mode

  #ifdef MASTER
    CANSetFilterScale32(0, _CAN_FILTER_ENABLED & _CAN_FILTER_ID_MASK_MODE & _CAN_FILTER_XTD_MSG, ID_1st, -1);
  #endif
  
  #ifdef SLAVE
    CANSetFilterScale32(0, _CAN_FILTER_ENABLED & _CAN_FILTER_ID_MASK_MODE & _CAN_FILTER_XTD_MSG, ID_2nd, -1);
  #endif
  
  CAN1SetOperationMode(_CAN_OperatingMode_Normal);                           // set NORMAL mode

  Msg_Rcvd = CAN1Read(0, &Rx_ID , RxTx_Data , &Rx_Data_Len, &Can_Rcv_Flags); // receive message

  #ifdef MASTER
    if ((Rx_ID == ID_1st) && Msg_Rcvd) {                                       // Master
  #endif

  #ifdef SLAVE
    if ((Rx_ID == ID_2nd) && Msg_Rcvd) {                                       // if message received check id
  #endif

  switch (RxTx_Data[0]) {
    case 1 : {
               if (LED1 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
               }
               LED1++;
               TFT_Set_Pen(CL_WHITE, 1);
               TFT_Circle(300, 360, 20);
             }; break;

    case 2 : {
               if (LED2 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
               }
               LED2++;
               TFT_Set_Pen(CL_WHITE, 1);
               TFT_Circle(300, 300, 20);
             }; break;

    case 4 : {
               if (LED3 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
               }
               LED3++;
               TFT_Set_Pen(CL_WHITE, 1);
               TFT_Circle(300, 240, 20);
             }; break;

    case 8 : {
               if (LED4 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
               }
               LED4++;
               TFT_Set_Pen(CL_WHITE, 1);
               TFT_Circle(300, 180, 20);
             }; break;

    case 16: {
               if (LED5 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
               }
               LED5++;
               TFT_Set_Pen(CL_WHITE, 1);
               TFT_Circle(220, 360, 20);
             }; break;

    case 32: {
               if (LED6 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
               }
               LED6++;
               TFT_Set_Pen(CL_WHITE, 1);
               TFT_Circle(220, 300, 20);
             };break;
    
    case 64: { 
               if (LED7 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
               }
               LED7++;
               TFT_Set_Pen(CL_WHITE, 1);
               TFT_Circle(220, 240, 20);
             }; break;
    
    case 128 : {
                 if (LED8 % 2) {
                 TFT_Set_Brush(1, CL_RED, 1, LEFT_TO_RIGHT, CL_PURPLE, CL_RED);
               }
               else {
                 TFT_Set_Brush(1, 0x4229, 0, LEFT_TO_RIGHT, CL_BLACK, CL_WHITE);
                 }
                 LED8++;
                 TFT_Set_Pen(CL_WHITE, 1);
                 TFT_Circle(220, 180, 20);
               }; break;
  }
  }
  

    #ifdef MASTER
      CAN1Write(ID_2nd, &CAN_Button, 1, Can_Send_Flags);
    #endif

    #ifdef SLAVE
      CAN1Write(ID_1st, &CAN_Button, 1, Can_Send_Flags);
    #endif

    CAN_Button = 0;
  delay_ms(10);
}