#include "mikromedia_7_objects.h"
#include "mikromedia_7_resources.h"

#include <stdint.h>

#define BUFSIZE 2048
#define NULL_POINTER 0

sfr sbit
  Net_Wireless_SPWF01S_En at GPIOF_ODR.B10;

char WiFi_flag = 1;

uint8_t
  wifiTest = 0,
  netReady = 0,
  lastChr  = 0x2A, // star symbol is ignored
  socketWaitTime[] = "6",

  strToSend[] = "0,0,0,********************:ue\r";
TLabel*
  currLine = &line1;

uint32_t
  baudRate    = 115200;

uint8_t
  currIdx     = 0,
  currLineNum = 1,
  line1End    = 0,
  line2End    = 0,
  line3End    = 0,
  newChrIdx   = 6,
  screenEnd   = 0,
  firstTime   = 1;

int8_t
  wifiStatus;
uint8_t
  netNum,
  mySSID[] = "MikroE Private",
  myPass[] = "mikroELEKTRONIKA",
//  mySSID[] = "lajkanet",
//  myPass[] = "djumbirnakurkumi",
  scanBuf[BUFSIZE],
  ssidLen,
  netType,
  chNum,
  ssid[32],
  macAddr[6],
  ipAddr[4],
  ipStr[16],
  wpa,
  wpa2,
  wps;

int16_t
  sigStr;
uint16_t
  capab;
uint16_t extern
  caption_length,
  caption_height;

// declarations
//void WriteCharOnScreen();

uint8_t
  html[] =
  "\
<!DOCTYPE html>\
<html>\
<head>\
<title>mikroe web server</title>\
<meta charset='UTF-8'>\
<style type='text/css'>\
@import url(http://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400);\
.left  {float: left;}\
.right {float: right;}\
.clear {clear: both;}\
html, body {\
background: #FFFFFF;\
margin:  0;\
padding: 0;\
font-family: 'Source Sans Pro', sans-serif;\
}\
.container {\
background: #FFFFFF;\
margin: 250px auto;\
width: 30%;\
text-align: center;\
}\
.content {\
float:      left;\
width:      100%;\
background: #F2F4F7;\
position: relative;\
}\
#header {\
background: #2C3E50;\
line-height: 2;\
margin:  0;\
font-size: 20px;\
color: #FFFFFF;\
border-radius: 4px;\
}\
#incTxt {\
float: left;\
width: 60%;\
padding: 5%;\
word-wrap: break-word;\
text-align: left;\
}\
#leds {\
width: 30%;\
float: right;\
padding: 0;\
margin:  0;\
}\
#minifooter {\
clear: both;\
display: none;\
}\
#footer {\
position: fixed;\
bottom:0;\
width:100%;\
height:75px;\
line-height:75px;\
background: #2C3E50;\
color: #FFFFFF;\
text-align: center;\
font-family: 'Source Sans Pro', sans-serif;\
font-size: 20px;\
text-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);\
display: none;\
}\
li {\
list-style: none;\
text-align: center;\
cursor: pointer;\
padding: 20px 0px;\
transition: all .3s ease;\
color: #7F7F7F;\
font-size: 16px;\
opacity: 1;\
}\
li:hover {\
opacity: 0.75;\
}\
.red_off {\
background: #ECF0F1;\
border-bottom: 1px solid #FFFFFF;\
border-left:  1px solid #FFFFFF;\
}\
.green_off {\
background: #ECF0F1;\
border-bottom: 1px solid #FFFFFF;\
border-left:  1px solid #FFFFFF;\
}\
.blue_off {\
background: #ECF0F1;\
border-bottom: 1px solid #FFFFFF;\
border-left:  1px solid #FFFFFF;\
}\
.red_on {\
background: #D00032;\
text-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);\
color:      #FFFFFF;\
}\
.green_on {\
background: #29B865;\
text-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);\
color:      #FFFFFF;\
}\
.blue_on {\
background: #2980B9;\
text-shadow: 0 1px 1px rgba(0, 0, 0, 0.2);\
color:      #FFFFFF;\
}\
</style>\
<script type='text/javascript' src='https://ajax.googleapis.com/ajax/libs/jquery/1.11.2/jquery.min.js'></script>\
<script type='text/javascript' src='led_and_keyb.js'></script>\
</head>\
<body>\
<div class='container'>\
<div id='header'>mikromedia7 Web Server</div>\
<div class='content'>\
<div id='incTxt'>Type on mikromedia!</div>\
<ul id='leds'>\
<li class='red_off'   >RED LED  </li>\
<li class='green_off' >GREEN LED</li>\
<li class='blue_off'  >BLUE LED </li>\
</ul>\
</div>\
<div id='minifooter'>Web server is busy.</div>\
</div>\
<div id='footer'>Connecting...</div>\
</body>\
</html>\
",
  js[] =
  "\
var\r\n\
  queryInterval  = 1000,\r\n\
  socketWaitTime = 6000,\r\n\
  redLedCLick    = 0,\r\n\
  greenLedClick  = 0,\r\n\
  blueLedClick   = 0,\r\n\
  chrDrawn       = 0,\r\n\
  rLedState      = '0',\r\n\
  gLedState      = '0',\r\n\
  bLedState      = '0',\r\n\
  rxChr          = '0',\r\n\
  serverBusy     = 0,\r\n\
  firstTime      = 1;\r\n\
$(document).on('click', '.red_off',  function () {\r\n\
  redLedCLick = 1;\r\n\
});\r\n\
$(document).on('click', '.green_off', function () {\r\n\
  greenLedClick = 1;\r\n\
});\r\n\
$(document).on('click', '.blue_off',  function () {\r\n\
  blueLedClick = 1;\r\n\
});\r\n\
function wait(timeToWait)\r\n\
{\r\n\
  var deferred = $.Deferred();\r\n\
  setTimeout(function() {\r\n\
    deferred.resolve();\r\n\
  }, timeToWait);\r\n\
  return deferred.promise();\r\n\
}\r\n\
function asciiDif(a, idx, b)\r\n\
{\r\n\
    return Math.abs( a.charCodeAt(idx) - b.charCodeAt(0) );\r\n\
}\r\n\
function AnalyzeData(data, status)\r\n\
{\r\n\
  if (status == 'success')\r\n\
  {\r\n\
    var resp = data.substring(data.indexOf('<!--#input-->')+13, data.indexOf(' </p>') );\r\n\
    if ( resp == 'WebServer currently busy. Please try again later.')\r\n\
    {\r\n\
      if (serverBusy == 0)\r\n\
      {\r\n\
        serverBusy = 1;\r\n\
        $('#minifooter').slideToggle('slow');\r\n\
        wait(queryInterval).then(SyncMikromedia);\r\n\
        return;\r\n\
      }\r\n\
    }\r\n\
    else if (serverBusy == 1)\r\n\
    {\r\n\
      serverBusy = 0;\r\n\
      $('#minifooter').slideToggle('slow');\r\n\
    }\r\n\
    if ( asciiDif(resp, 0, rLedState) === 1 )\r\n\
    {\r\n\
      $('.red_off').toggleClass('red_on');\r\n\
      rLedState = resp[0];\r\n\
    }\r\n\
    if ( asciiDif(resp, 2, gLedState) === 1 )\r\n\
    {\r\n\
      $('.green_off').toggleClass('green_on');\r\n\
      gLedState = resp[2];\r\n\
    }\r\n\
    if ( asciiDif(resp, 4, bLedState) === 1 )\r\n\
    {\r\n\
      $('.blue_off').toggleClass('blue_on');\r\n\
      bLedState = resp[4];\r\n\
    }\r\n\
    if (firstTime === 1)\r\n\
    {\r\n\
      $('#incTxt').text('');\r\n\
      firstTime = 0;\r\n\
    }\r\n\
    if (resp.substring(27,29) === 'ue')\r\n\
    {\r\n\
      for (var i = 6; i <= 25; i++)\r\n\
      {\r\n\
        rxChr = resp[i];\r\n\
        switch(rxChr)\r\n\
        {\r\n\
          case '*':\r\n\
          {\r\n\
            break;\r\n\
          }\r\n\
          case 'b':\r\n\
          {\r\n\
            $('#incTxt').html( $('#incTxt').html().slice(0, -1) );\r\n\
            break;\r\n\
          }\r\n\
          case 'e':\r\n\
          {\r\n\
            $('#incTxt').append('<br/>');\r\n\
            break;\r\n\
          }\r\n\
          case 'z':\r\n\
          {\r\n\
            $('#incTxt').empty();\r\n\
            break;\r\n\
          }\r\n\
          default:\r\n\
          {\r\n\
            $('#incTxt').append(rxChr);\r\n\
          }\r\n\
        }\r\n\
      }\r\n\
    }\r\n\
    wait(queryInterval).then(SyncMikromedia);\r\n\
  }\r\n\
}\r\n\
function SendData()\r\n\
{\r\n\
  if (redLedCLick == 1)\r\n\
  {\r\n\
    redLedCLick = 0;\r\n\
    $.get('output.cgi',\r\n\
      {\r\n\
        text: 'rled'\r\n\
      });\r\n\
  }\r\n\
  if (greenLedClick == 1)\r\n\
  {\r\n\
    greenLedClick = 0;\r\n\
    $.get('output.cgi',\r\n\
      {\r\n\
        text: 'gled'\r\n\
      });\r\n\
  }\r\n\
  if (blueLedClick == 1)\r\n\
  {\r\n\
    blueLedClick = 0;\r\n\
    $.get('output.cgi',\r\n\
      {\r\n\
        text: 'bled'\r\n\
      });\r\n\
  }\r\n\
  return $.ajax({\r\n\
    url: 'input.cgi',\r\n\
    data:\r\n\
    {\r\n\
      input: 'on'\r\n\
    }\r\n\
  });\r\n\
}\r\n\
function SyncMikromedia()\r\n\
{\r\n\
  SendData()\r\n\
    .done(AnalyzeData)\r\n\
    .fail(function () {\r\n\
      $('#footer').slideToggle('slow');\r\n\
      wait(socketWaitTime).then(function () {\r\n\
        $('#footer').slideToggle('slow');\r\n\
        SyncMikromedia();\r\n\
      });\r\n\
    });\r\n\
}\r\n\
$( document ).ready(function () {\r\n\
  SyncMikromedia();\r\n\
});\
";

static void UartInit(uint32_t baudRate)
{
  // set SPWF01S UART
  UART6_Init_Advanced(baudRate, 8, 0, 1, &_GPIO_MODULE_USART6_PC67);
  Delay_ms(100);

  // enable RX interrupt
  RXNEIE_USART6_CR1_bit = 1;
  NVIC_IntEnable(IVT_INT_USART6);
  EnableInterrupts();
}

static void UpdateDescription(
                              uint8_t* newText
                              )
{
  // clear line
  TFT_Set_Font  (Diagram14_desc.FontName, CL_WHITE,  FO_HORIZONTAL);
  TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left, Diagram14_desc.Top);
  // update label
  strcpy(Diagram14_desc.Caption, newText);
  // update line
  TFT_Set_Font  (Diagram14_desc.FontName, Diagram14_desc.Font_Color, FO_HORIZONTAL);
  TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left,       Diagram14_desc.Top);
}

/**
 * left-justify strings, which are right-justified by default in mikroC
 * @param  str string after some conversion fcn
 * @return 0 - success
 *        -6 - failure
 */
static uint8_t cutLeadSpaces(uint8_t** str)
{
  // truncate leading blanks, since the given string is right-justified
  while (1)
  {
    // erase spaces
    if (**str == ' ')
    {
      (*str)++;
    }
    // if null is reached, something's not good
    else if (**str == 0)
    {
      return _NET_WIRELESS_SPWF01S_ERROR;
    }
    // we reached non-zero character, return the pointer
    else
    {
      return _NET_WIRELESS_SPWF01S_OK;
    }
  }
}

/**
 * IP 4-array -> STRING
 * @param  ipAddr 4-element array
 * @param  str    string, , of at least 16 chars
 * @return        pointer to the resulting IP address array, of at least 16 chars
 */
static uint8_t* IP2Str(
                         uint8_t* ipAddr
                       , uint8_t* str
                       )
{
  uint8_t
    // counter
    i = 0,
    // temporary buffer
    tmpBuff[4],
    *ipStrPtr;

  for (i = 0; i < 3; ++i)
  {
    // ip number -> string
    ByteToStr(ipAddr[i], tmpBuff);
    ipStrPtr = tmpBuff;
    if ( cutLeadSpaces(&ipStrPtr) != _NET_WIRELESS_SPWF01S_OK )
    {
      return NULL_POINTER;
    }
    strcat(str, ipStrPtr);
    strcat(str, ".");
  }

  // one more time, without the final dot
  ByteToStr(ipAddr[3], tmpBuff);
  ipStrPtr = tmpBuff;
  if ( cutLeadSpaces(&ipStrPtr) != _NET_WIRELESS_SPWF01S_OK )
  {
    return NULL_POINTER;
  }
  strcat(str, ipStrPtr);

  return str;
}

/**
 * search for the particular network and returns its parameters
 * @param  wantedSSID network which is sought after
 * @param  scanBuf    user-supplied buffer for scanning
 * @param  bufLen     buffer's length
 * @param  netType    wanted network type
 * @param  chNum      wanted network channel number
 * @param  sigStr     wanted network signal strength
 * @param  capab      wanted network capabilities information field
 * @param  macAddr    wanted network MAC address
 * @param  wpa        "is WPA present?"  flag
 * @param  wpa2       "is WPA2 present?" flag
 * @param  wps        "is WPS present?"  flag
 * @param  numTry     number of tries
 */
void scanForSSID(
                     uint8_t* wantedSSID
                   , uint8_t* scanBuf
                   , uint16_t bufLen
                   , uint8_t* netType
                   , uint8_t* chNum
                   , uint8_t* sigStr
                   , uint8_t* capab
                   , uint8_t* macAddr
                   , uint8_t* wpa
                   , uint8_t* wpa2
                   , uint8_t* wps
                   , uint8_t  numTry
                   )
{
  int8_t
    wifiStatus = 0;
  uint8_t
    netNum     = 0,
    i          = 0,
    j          = 0,
    ssidLen    = 0,
    ssid[32];

  for (i = 0; i < numTry; i++)
  {
    if ( (wifiStatus = Net_Wireless_SPWF01S_Scan(&netNum, scanBuf, bufLen)) == _NET_WIRELESS_SPWF01S_OK )
    {
      UpdateDescription("Scanning...");
      for (j = 1; j <= netNum; j++)
      {
        if ( ( wifiStatus = Net_Wireless_SPWF01S_GetScanResultByIndex(j, scanBuf, &ssidLen, netType, chNum, sigStr, capab, ssid, macAddr, wpa, wpa2, wps) ) == _NET_WIRELESS_SPWF01S_OK )
        {
          // update label
          TFT_Set_Font  (Diagram14_desc.FontName, CL_WHITE,  FO_HORIZONTAL);
          TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left, Diagram14_desc.Top);
          strcat( strcpy(Diagram14_desc.Caption, "Network: "), ssid );
          TFT_Set_Font  (Diagram14_desc.FontName, Diagram14_desc.Font_Color, FO_HORIZONTAL);
          TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left,       Diagram14_desc.Top);
          Delay_ms(500);

          if ( strcmp(ssid, wantedSSID) == 0 )
          {
            UpdateDescription("Network found!");
            Delay_ms(500);

            Net_Wireless_SPWF01S_GetScanResultBySSID(wantedSSID, scanBuf, netType, chNum, sigStr, capab, macAddr, wpa, wpa2, wps);
            return;
          }
          if ( i == (numTry-1) )
          {
            TFT_Set_Font  (Diagram14_desc.FontName, CL_WHITE,  FO_HORIZONTAL);
            TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left, Diagram14_desc.Top);
            strcat( strcpy(Diagram14_desc.Caption, "Number of trials exceeded."), ssid );
            TFT_Set_Font  (Diagram14_desc.FontName, Diagram14_desc.Font_Color, FO_HORIZONTAL);
            TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left,       Diagram14_desc.Top);
            Delay_ms(500);
          }
        }
        else
        {
          TFT_Set_Font  (Diagram14_desc.FontName, CL_WHITE,  FO_HORIZONTAL);
          TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left, Diagram14_desc.Top);
          strcat( strcpy(Diagram14_desc.Caption, "Network not found!"), ssid );
          TFT_Set_Font  (Diagram14_desc.FontName, Diagram14_desc.Font_Color, FO_HORIZONTAL);
          TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left,       Diagram14_desc.Top);
          Delay_ms(500);
        }
      }
    }
    else
    {
      TFT_Set_Font  (Diagram14_desc.FontName, CL_WHITE,  FO_HORIZONTAL);
      TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left, Diagram14_desc.Top);
      strcat( strcpy(Diagram14_desc.Caption, "Manual scan request denied."), ssid );
      TFT_Set_Font  (Diagram14_desc.FontName, Diagram14_desc.Font_Color, FO_HORIZONTAL);
      TFT_Write_Text(Diagram14_desc.Caption,  Diagram14_desc.Left,       Diagram14_desc.Top);
      Delay_ms(500);
    }
  }
}

/**
 *  matching with known string
 */
uint8_t matchResponse(
                        uint8_t   newChr
                      , uint8_t*  knMsg
                      , uint8_t*  idx
                      )
{
  // compare read char with tracking character in the string
  if ( newChr == *(knMsg + *idx) )
  {
    // update tracking index
    (*idx)++;
    // if we reached the end of the known string, exit with success msg
    if ( *(knMsg + *idx) == 0 )
    {
      *idx  = 0;
      return 1;
    }
  }

  // if no match, reset tracking index and compare again
  else
  {
    *idx = 0;
    if (newChr == *knMsg)
    {
      // update tracking index
      (*idx)++;
    }
  }

  // nothing, yet
  return _NET_WIRELESS_SPWF01S_OK;
}

uint8_t
  rLedIdx   = 0,
  gLedIdx   = 0,
  bLedIdx   = 0,
  kbIdx     = 0,
  chrIdx    = 0,

  rQuery    = 0,
  gQuery    = 0,
  bQuery    = 0,
  kbQuery   = 0;

// wind callback
int8_t windCB(
                uint32_t WID
              , uint8_t* windResp
              )
{
  uint8_t
    // local counter
    i;

  // wifi is up
  if (
      Net_Wireless_SPWF01S_GetWID() == _NET_WIRELESS_SPWF01S_WID_CONNECT_OK
      )
  {
    netReady = 1;
  }

  // input is waiting
  if (
         ( Net_Wireless_SPWF01S_GetWID() == _NET_WIRELESS_SPWF01S_WID_INPUT_REQ )
      && (                      netReady == 1                                   )
      )
  {
    strToSend[0] = ODR15_GPIOG_ODR_bit + '0';
    strToSend[2] = ODR3_GPIOB_ODR_bit  + '0';
    strToSend[4] = ODR4_GPIOB_ODR_bit  + '0';

    // mark unused characters with '*' placeholders
    if (newChrIdx <= 25)
    {
      for (i = newChrIdx; i <= 25; i++)
      {
        strToSend[i] = '*';
      }
    }
    UART_Write_Text(strToSend);
    // reset index
    newChrIdx = 6;
  }

  return 0;
}

// user callback
int8_t usrCb(
             uint8_t readData
             )
{
  // toggle LEDS
  if (
      matchResponse(readData, "rled" , &rLedIdx) == 1
      )
  {
    ODR15_GPIOG_ODR_bit = ~ODR15_GPIOG_ODR_bit;
  }
  if (
      matchResponse(readData, "gled" , &gLedIdx) == 1
      )
  {
    ODR3_GPIOB_ODR_bit = ~ODR3_GPIOB_ODR_bit;
  }
  if (
      matchResponse(readData, "bled" , &bLedIdx) == 1
      )
  {
    ODR4_GPIOB_ODR_bit = ~ODR4_GPIOB_ODR_bit;
  }

  return _NET_WIRELESS_SPWF01S_OK;
}

void initWiFi()
{
  UartInit(baudRate);

  // set timer 2: IRQ@1s
  RCC_APB1ENR.TIM3EN = 1;
  TIM3_CR1.CEN       = 0;
  TIM3_PSC           = 2239;
  TIM3_ARR           = 62499;
  NVIC_IntEnable(IVT_INT_TIM3);
  TIM3_DIER.UIE      = 1;
  TIM3_CR1.CEN       = 1;

  // Wifi module init
  Net_Wireless_SPWF01S_Init();
  Net_Wireless_SPWF01S_SetAICallback(&WindCb);
  Net_Wireless_SPWF01S_SetUserCallback(&UsrCb);

  // set LED pins as ouput
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_3 | _GPIO_PINMASK_4);
  GPIO_Digital_Output(&GPIOG_BASE, _GPIO_PINMASK_15);


}

void startServer()
{
  // set timewait state to be lower than default 12s
  Net_Wireless_SPWF01S_SetConfig(_NET_WIRELESS_SPWF01S_CFG_WAIT_TIME, socketWaitTime);

  // scan for SSID
  scanForSSID(mySSID, scanBuf, BUFSIZE, &netType, &chNum, &sigStr, &capab, macAddr, &wpa, &wpa2, &wps, 10);

  // connect to the network
  netReady = 0;
  UpdateDescription("Connecting...");
  if ( ( wifiTest = Net_Wireless_SPWF01S_ConnectToAP(mySSID, myPass) ) == _NET_WIRELESS_SPWF01S_OK )
  {
    // wait for WiFi to be up
    while (netReady == 0) {}

    UpdateDescription("Connected!");

    // create files
    Net_Wireless_SPWF01S_MakeFile("index.html", html);
    Net_Wireless_SPWF01S_MakeFile("led_and_keyb.js", js);

    DrawScreen(&Screen1);
    TFT_Set_Font  (ipLabel.FontName, 0x4229,     FO_HORIZONTAL);
    TFT_Write_Text(ipLabel.Caption,  ipLabel.Left, ipLabel.Top);
    Net_Wireless_SPWF01S_GetCurrentIP(ipAddr);
    strcat( strcpy(ipLabel.Caption, "Type in your browser: "), ip2Str(ipAddr, ipStr) );
    TFT_Set_Font  (ipLabel.FontName, ipLabel.Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ipLabel.Caption,  ipLabel.Left,       ipLabel.Top);
  }
}

void SaveChar(uint8_t chr)
{
  lastChr = chr;
  if (newChrIdx <= 25)
  {
    strToSend[newChrIdx++] = lastChr;
  }
}

void WriteOnScr()
{
  switch(lastChr)
  {
    // enter
    case 0x65:
    {
      // if we're not on the last line already
      if ( currLineNum != 3)
      {
        // update current line
        currLine->Caption[currIdx]   = 0;
        TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
        TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);

        switch(currLineNum)
        {
          case 1:
          {
            line1End    = currIdx;
            currLine    = &line2;
            currLineNum = 2;
            break;
          }
          case 2:
          {
            line2End    = currIdx;
            currLine    = &line3;
            currLineNum = 3;
            break;
          }
          case 3:
          {
            return;
          }
        }
        currIdx = 0;
        currLine->Caption[currIdx] = 95;
        // update current line
        TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
        TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);
      }
      else
      {
        // update current line
        TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
        TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);
      }
      break;
    }

    // backspace
    case 0x62:
    {
      if (currIdx == 0)
      {
        switch(currLineNum)
        {
          case 1:
          {
            // nothing to do, just rewrite current line
            TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
            TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);
            return;
          }
          case 2:
          {
            currLineNum = 1;
            currLine    = &line1;
            currIdx     = line1End;
            break;
          }
          case 3:
          {
            currLineNum = 2;
            currLine    = &line2;
            currIdx     = line2End;
            break;
          }
        }
        // erase new line
        TFT_Set_Font  (currLine->FontName, CL_WHITE,       FO_HORIZONTAL);
        TFT_Write_Text(currLine->Caption,  currLine->Left, currLine->Top);
        // update wth underscore at the end
        currLine->Caption[currIdx] = 95;
      }
      else
      {
        currLine->Caption[currIdx]   = 0;
        currLine->Caption[--currIdx] = 95;
        if (screenEnd == 1)
        {
          screenEnd = 0;
        }
      }
      // write new line
      TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
      TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);
      break;
    }

    // char
    default:
    {
      if (screenEnd == 0)
      {
        currLine->Caption[currIdx++] = lastChr;

        // if the end of line is reached, write underscore on the next line
        TFT_Write_Text_Return_Pos(currLine->Caption, currLine->Left, currLine->Top);
        if (caption_length >= 750)
        {
          // rewrite current line
          TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
          TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);

          switch(currLineNum)
          {
            case 1:
            {
              line1End    = currIdx-1;
              currLine    = &line2;
              currLineNum = 2;
              break;
            }
            case 2:
            {
              line2End    = currIdx-1;
              currLine    = &line3;
              currLineNum = 3;
              break;
            }
            case 3:
            {
              currIdx--;
              screenEnd = 1;
              return;
            }
          }
          currIdx = 0;
        }
        // write underscore
        currLine->Caption[currIdx] = 95;

        // update line
        TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
        TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);
      }
      else
      {
        // rewrite current line
        TFT_Set_Font  (currLine->FontName, currLine->Font_Color, FO_HORIZONTAL);
        TFT_Write_Text(currLine->Caption,  currLine->Left,       currLine->Top);
      }
    }
  }
}

void WriteCharOnScreen()
{
  uint8_t
    // local counter
    i;

  // erase current line
  TFT_Set_Font  (currLine->FontName, CL_WHITE,       FO_HORIZONTAL);
  TFT_Write_Text(currLine->Caption,  currLine->Left, currLine->Top);

  // only for first char, erase the beginning text
  if (firstTime == 1)
  {
    for (i = 0; i < 50; i++)
    {
      currline->Caption[i] = 0;
    }
    firstTime = 0;
  }
  WriteOnScr();
}

// interrupts
/////////////

// increase timer value
void incTimer() iv IVT_INT_TIM3
{
  TIM3_SR.UIF = 0;
  Net_Wireless_SPWF01S_IncTimer();
}

void asyncReq() iv IVT_INT_USART6 ics ICS_AUTO
{
  Net_Wireless_SPWF01S_Read();
}

void doWiFi(){
  if (WiFi_flag == 1){
    WiFi_flag = 0;
    initWiFi();
    startServer();
  }
  else{
      Delay_ms(5);
  }
}